#include "SquareOverlay.h"
#include "../../simplexnoise/simplexnoise1234.h"

#define SQUARE_WIDTH_VAR 0

#define WIDTH_OF_SQUARE 5.0f

SquareOverlay::SquareOverlay(int type_id) : Renderable(type_id)
{
}

SquareOverlay::~SquareOverlay(void)
{
}

bool SquareOverlay::inSquare(int x, int y)
{
	//square and spacing fits in unit width/height.
	//for now, squares remain squares. No stretching on any axis.

	float xpos = x, ypos = y;
	m_windowMapping.PixelPositionToSpace(xpos, ypos);
	float squareWidth, squareHeight, squareSpacingX, squareSpacingY;

	//get a fixed point in the cell where this square should be
	float square_cell_x, square_cell_y;
	square_cell_x = DivFloat(xpos, WIDTH_OF_SQUARE);
	square_cell_y = DivFloat(ypos, WIDTH_OF_SQUARE);

	//translate back to pixels
	int xx, yy;
	m_windowMapping.SpaceToPixel(square_cell_x, square_cell_y, xx, yy);
	squareHeight = squareWidth = m_layerVariables[SQUARE_WIDTH_VAR].GetValue(xx, yy);

	//squareHeight = squareWidth = 2.0f;
	squareSpacingX = squareSpacingY = WIDTH_OF_SQUARE - squareHeight;

	xpos = ModFloat(xpos, WIDTH_OF_SQUARE);
	ypos = ModFloat(ypos, WIDTH_OF_SQUARE);
	if((xpos>0) && (ypos>0) && (xpos < squareWidth) && (ypos < squareHeight))
		return true;

	return false;
}

float SquareOverlay::GetRawValueAt(int x, int y)
{
	float gray;

	if(inSquare(x, y))
		gray = 1.0f;
	else
		gray = 0.0f;

	return gray;
}


void SquareOverlay::SetVariables()
{
	m_layerVariables[SQUARE_WIDTH_VAR].Initialize(this, "Width", 2.0f, 5.0f, 0.001f);
	m_variableCount = 1;
}